Hey, I am Huang, Xuan (a.k.a. _@huxpro_). I worked on the [React Team](https://beta.reactjs.org/community/meet-the-team#react-core) at <del>Facebook</del>Meta.

I considered myself as a hybrid between a software engineer specifically into the programming languages theories and implementations domain (i.e. compiler, type system, type-based formal verification, virtual machine, runtime systems, garbage collection), and a creative technologiest deeply caring about many humanistic aspects (e.g. visual, sound, interaction) in UI and HCI in general.

I also worked on the [Hermes JavaScript Engine](https://hermesengine.dev/), some other projects under the [Reality Labs (Research)](https://tech.fb.com/ar-vr/), and [ReasonML](https://reasonml.github.io/) (now [ReScript](https://rescript-lang.org/)) efforts at Meta (Facebook).

In the past, I worked on [Alitrip (Fliggy)](https://www.alitrip.com/) mobile and web apps under the [Alibaba Group](https://en.wikipedia.org/wiki/Alibaba_Group), found and lead front-end infrastructure team at an unicorn startup company [Beijing Weiying (a.k.a. WePiao, now acquired by Maoyan)](https://www.crunchbase.com/organization/beijing-weiying-technology), and helped [Ele.me (now acquired by Alibaba)](https://en.wikipedia.org/wiki/Ele.me) to upgrade their mobile web site into [the first influential PWA (progressive web app) in China](https://medium.com/elemefe/upgrading-ele-me-to-progressive-web-app-2a446832e509).

I studied BA, Digital Media Art at [Communication University of China](https://en.wikipedia.org/wiki/Communication_University_of_China) and MS, Computer Science (with a focus on programming languages, mainly supervised by [Prof. Matthew Fluet](https://www.cs.rit.edu/~mtf/)) at [Rochester Institute of Technology](https://en.wikipedia.org/wiki/Rochester_Institute_of_Technology).

##### Appearence

- [React Labs: What We've Been Working On – June 2022][12] · React Blog · 2022
- [React Without Memo][11] · [React Conf 2021](https://conf.reactjs.org/)
- [Toward Hermes being the Default][11] · React Native Blog · 2021
- React Native 0.64 with Hermes for iOS · [The RN Show Podcast Ep #5](https://www.callstack.com/podcast-react-native-show) · 2021
- [Upgrading to Progressive Web Apps][9] · [JSConf China Shanghai 2017](http://2017.jsconf.cn/)
- Building Progressive Web Apps · [CSDI Guangzhou 2017](http://www.csdisummit.com/)
- The State of Progressive Web App · GDG IO Redux Beijing 2017
- PWA Rehashing · Baidu HQ Beijing 2017
- [Service Worker 101][5] · GDG DevFest Beijing 2016
- [Progressive Web Apps][4] · QCon Shanghai 2016
- Progressive Web App in my POV · GDG IO Redux Beijing 2016
- [CSS Still Sucks 2015][2] · 2015
- [JavaScript Modularization Journey][1] · 2015

[1]: //huangxuan.me/2015/07/09/js-module-7day/
[2]: //huangxuan.me/2015/12/28/css-sucks-2015/
[3]: //huangxuan.me/2016/06/05/pwa-in-my-pov/
[4]: //huangxuan.me/2016/10/20/pwa-qcon2016/
[5]: //huangxuan.me/2016/11/20/sw-101-gdgdf/
[6]: https://yanshuo.io/assets/player/?deck=58ac8598b123db0067292f92 "PWA Rehashing"
[7]: https://yanshuo.io/assets/player/?deck=593ad6fbfe88c2006a0a0d6d "The State of PWA"
[8]: https://yanshuo.io/assets/player/?deck=594d673d570c357d0698a950 "Building PWA"
[9]: //huangxuan.me/jsconfcn2017/
[10]: https://reactnative.dev/blog/2021/10/26/toward-hermes-being-the-default
[11]: https://youtu.be/lGEMwh32soc
[12]: https://reactjs.org/blog/2022/06/15/react-labs-what-we-have-been-working-on-june-2022.html
