---
layout: post
title: "作为一个前端，看不懂@黄玄 的几乎每一个回答，只有我自己吗？"
subtitle: "Taking this chance to reflect on myself"
author: "Hux"
header-style: text
tags:
  - 知乎
  - Meta
---

> 这篇文章转载自[我在知乎上的回答](https://www.zhihu.com/question/403735935/answer/1321904076)

我也看不懂。
------

对于任何一个我有一定了解的领域，我都知道一大堆我看不懂的东西。反而是对于那些我一点都不了解的，我甚至都说不出来我不懂什么。

有的时候我会觉得，在我眼里还只有前端的时候，我还更自信更爱分享一点。可能因为那时候我能感知到的「边界」就只有 2^4 = 16 这么大，还觉得自己满打满算已经懂了 4 吧。打个比喻的话就是觉得自己已经能干活了，但还想再了解下 JS 引擎、浏览器、框架等的工作原理，或许还想再多学点后端和移动端当个全栈？总之 4/16 已经是「全集」的 25% 了，觉得自己还挺棒棒哒。

结果等我的「知识」真成长到 16 时，才意识到「欧，原来计算机科学还有这么多东西」？而且每个领域水都深得很，教科书里引论文，论文里再引更多论文，像一棵棵树般不断分形出去…认知的「边界」也相应的长到了 2^16 = 65536。自己懂的东西只占 0.02%，一下觉得自己真是什么都不是了。我把这个瞎掰称之为「认知的指数成长理论」。

而我能做的就是学会与这样的认知和平共处。Prof. Matt Might 画的那篇 The illustrated guide to a Ph.D[\[1\]](#ref_1)（[「博士是什么」](https://zhuanlan.zhihu.com/p/19789670)) 让我意识到个体在「人类所有知识」面前的渺小，而「成长」的过程，大概就是在那个愈发巨大的「看不懂集」里，挑选出你还愿意继续去「探索」的那些「子集」吧。

![](https://picx.zhimg.com/50/v2-9557bd0507ca70f7afd075730f31a2e3_720w.jpg?source=1940ef5c)

![](https://picx.zhimg.com/80/v2-9557bd0507ca70f7afd075730f31a2e3_720w.jpg?source=1940ef5c)

「认知的指数成长理论」

作为一个前端。
-------

在相当长的一段时间里，「前端」既是我的兴趣也是我的职业，那时好像不需要有区别 —— 从早早在阿里实习，到还没毕业就在微影带团队，小中大的公司都待过，活动也参加了不少。其实如果就这样专注于「作为一个前端」，应该现在也还混得不赖吧。

可是偏偏你就发现，那个「看不懂集」的边缘总在发着光 —— 群友形容有一部人的动力在于「理解驱动」，我想了想，那或许是我「半路出家」积累的太多疑惑需要解答；又或许，我可能只是想要「旅游」吧 —— 在高三从重点班理科生转了艺术，在阿里从交互又转了前端，可我还有好奇的理论、又或者还没尝试过系统编程，又或者是下一个有趣的产品形态……想去探索下一件事的欲望总是逐渐盖过了舒适感，你听说了那个学科，你听说了那个文明，你听说了风暴中心，可是你不去看，你就永远不知道那里是什么样。

最近多次被问及「前端团队的方向是什么？」才突然意识到自己有一段时间不这样思考了 —— 这个问题天生就带着市场环境强调[精细化分工](https://www.zhihu.com/search?q=%E7%B2%BE%E7%BB%86%E5%8C%96%E5%88%86%E5%B7%A5&search_source=Entity&hybrid_search_source=Entity&hybrid_search_extra=%7B%22sourceType%22%3A%22answer%22%2C%22sourceId%22%3A1321904076%7D)的倾向，而相反地，有时我惊讶于 Facebook 内部「疏于管理」得就像个[开源软件](https://www.zhihu.com/search?q=%E5%BC%80%E6%BA%90%E8%BD%AF%E4%BB%B6&search_source=Entity&hybrid_search_source=Entity&hybrid_search_extra=%7B%22sourceType%22%3A%22answer%22%2C%22sourceId%22%3A1321904076%7D)的菜市场。前端作为一个子领域当然需要特定的技术设施与人员的专长，但或许你我的职业/兴趣发展、公司的组织架构、软件的开发方式，不一定都非得绑上。

我想要追求的状态不只是能继续做我已经擅长的事情，我还想去探索那些我想要尝试但可能还不太擅长的事情，最后再顺便把钱赚着 —— 就美其名曰「技术自由」吧。所以你说，我是前端吗，我不是前端吗？

![](https://pic4.zhimg.com/50/v2-6caf0e597779eb690dffe71c0c610f54_720w.jpg?source=1940ef5c)

![](https://pic4.zhimg.com/80/v2-6caf0e597779eb690dffe71c0c610f54_720w.jpg?source=1940ef5c)

「专注」和「职业」又何必要是一个双射呢？



回答。
---

答题不是我的工作，我不做培训也不靠这个赚钱，不愿花时间琢磨如何哗众取宠，  
只是有时恰好有新的感悟可以分享，有时恰好有有趣的题目能引发我的思考；

答题只是博客之外另一个用写作自我沉淀的地方罢了，难免会有点自我，  
但反正也只是写给同路人看的，也为了发现与认识更多的同路人；

我不愿意「只」为了答题而写字，也还是希望言之有物，  
这道题如此 meta，是回答给谁呢，又或是回答给我呢？

结语。
---

有的时候需要赚钱，有的时候需要理想。  
你是更想做一位黑客与画家，还是想站在 Hilbert 第十问题的肩上。

Gödel 说太难，人生又怎会比 Peano 简单。  
面对的 [tradeoff](https://www.zhihu.com/search?q=tradeoff&search_source=Entity&hybrid_search_source=Entity&hybrid_search_extra=%7B%22sourceType%22%3A%22answer%22%2C%22sourceId%22%3A1321904076%7D) 太多，才只能去近似一个想要的模样。

说得都是走心的话，走脑还是多看书吧。  
如果能给在读的你带来一点不同思考，那便是对一个碳基生物所能给予的最高嘉奖了。



黄玄，
二〇二〇年七月五日，
于美国[圣塔克拉拉](https://www.zhihu.com/search?q=%E5%9C%A3%E5%A1%94%E5%85%8B%E6%8B%89%E6%8B%89&search_source=Entity&hybrid_search_source=Entity&hybrid_search_extra=%7B%22sourceType%22%3A%22answer%22%2C%22sourceId%22%3A1321904076%7D)。


_「有一部分朋友知道，我现在在探索的事情跟前端关系还挺近的啦。_
_希望我也能突破我自我驱动的局限性，多做一些更落地的事情吧！共勉！」_

参考
--

1.  The illustrated guide to a Ph.D [http://matt.might.net/articles/phd-school-in-pictures/](http://matt.might.net/articles/phd-school-in-pictures/)
